
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>mini2440裸机试炼之——看门狗中断和复位操作 / 憋错料</title>

    <meta name="description" content="mini2440裸机试炼之——看门狗中断和复位操作 看门狗的工作原理: 设本系统程序完整运行一周期的时间是Tp,看门狗的定时周期为Ti,Ti&gt;Tp,在程序正常运行时,定时器就不会溢出,若由于干扰等原因使系统不能在Tp时刻修改定时器的记数值,定时器将在Ti时刻溢出,引发系统复位,使系统得以重新运行,从而起到监控的作用. 看门狗具有两个功能: 1. 当做常规时钟,可以产生中断: 2. 当看门狗定时器使用,当计数器WTCNT为0时,产生复位: 看门狗的功能方框图: 我程序中PCLK为50MHz,预分频值=77,时钟除数因子选128, 时钟周期t_ ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">mini2440裸机试炼之——看门狗中断和复位操作</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>看门狗的工作原理：</h2>
<p>设本系统程序完整运行一周期的时间是Tp，看门狗的定时周期为Ti，Ti&gt;Tp，在程序正常运行时，定时器就不会溢出，若由于干扰等原因使系统不能在Tp时刻修改定时器的记数&#20540;，定时器将在Ti时刻溢出，引发系统复位，使系统得以重新运行，从而起到监控的作用。</p>
<h2>看门狗具有两个功能：</h2>
<p>1、&nbsp;当做常规时钟，可以产生中断；</p>
<p>2、&nbsp;当看门狗定时器使用，当计数器WTCNT为0时，产生复位；</p>
<h2>看门狗的功能方框图:</h2>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA3MjQxODQ3MzkyMDM/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YlhWNVlXNW5YM0psYmc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p>我程序中PCLK为50MHz，预分频&#20540;=77，时钟除数因子选128，</p>
<p>时钟周期t_watchdog=1/[PCLK/(预分频&#20540;&#043;1)/时钟除数因子]</p>
<p>=1/[50*1000000/(77&#043;1)/128]=0.0002</p>
<p>t_watchdog表示的是看门狗计数计时器WTCNT每减少1所用的时间，WTCNT又相当于一个节拍的作用，当WTCNT为0时，如果看门狗控制寄存器WTCON[0]开启复位功能，则复位；如果看门狗控制寄存器WTCON[0] 禁止复位，开启中断，则中断操作，并数据（WTDAT）寄存器重新赋&#20540;到计数（WTCNT）寄存器内，循环中断操作（这里的中断就类&#20284;RTC的闹钟中断）。</p>
<p>所谓的喂狗：就是使WTCNT在为0之前重新赋&#20540;，不使之发生中断或者复位。</p>
<p>引用赵老师的一段话：</p>
<p>s3c2440的看门狗定时器不仅可以引起系统复位，还可以引起一般的中断，因此s3c2440的看门狗定时器可以当作一般的定时器使用。</p>
<h2>看门狗中断结果：</h2>
<p>每四秒一个中断，LED点亮并串口提示</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA3MjQxODUyNDE5Mzc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YlhWNVlXNW5YM0psYmc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<h2>看门狗复位结果:</h2>
<p>AXD调试运行到看门狗计数器rWTCNT为零时,进入复位,CPU停止工作,也就不产生中断。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA3MjQxODUzMzI2NTM/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YlhWNVlXNW5YM0psYmc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA3MjQxODUzMzg4NDY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YlhWNVlXNW5YM0psYmc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p>复位关闭axd后,u-boot串口初始化提示(没能及时在第一次蜂鸣器响按下按键停止autoboot):</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA3MjQxODUzNTA5ODM/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YlhWNVlXNW5YM0psYmc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p>复位关闭axd后,u-boot串口初始化提示(及时在第一次蜂鸣器响按下按键停止autoboot):</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA3MjQxODUxMjY0Njg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YlhWNVlXNW5YM0psYmc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p>这里就是复位到用uboot初始化开发板的时候,但是不明白为什么必须要在第一次蜂鸣器就按下按键才能进到uboot</p>
<h2>附：</h2>
<p><strong>硬件环境：J-link v8、mini2440、J-link转接板、串口转USB线</strong></p>
<p><strong>软件环境：windows7（32位）、开发板uboot（NandFlash）、J-link驱动（J-Link ARM V4.10i）、SecureCRT、ADS1.2</strong></p>
<p><strong>&nbsp;</strong></p>
<p><strong>代码块</strong></p>
<pre>//====================================================================
//  实现功能：
//           看门狗中断和复位操作
//       当WTCON[0] 开启复位功能;                实现复位
//       当WTCON[0] 禁止复位，WTCON[2]开启中断;  实现中断
//                                                   by：梁惠涌
//====================================================================
#include &quot;2440addr.h&quot;
#include &quot;def.h&quot;
#include &quot;2440lib.h&quot;

static U8 led_flag=0;
/**************************************************************
                   看门狗初始化函数
**************************************************************/
void watchdog_init(){
    rWTCON=((77&lt;&lt;8)|(1&lt;&lt;5)|(3&lt;&lt;3)|(1&lt;&lt;2)); //预分频值=77;看门狗定时器使能;时钟除数因子=128 ;看门狗中断使能;
    //时钟周期t_watchdog=1/[PCLK/(预分频值+1)/时钟除数因子]=1/[50*1000000/(77+1)/128]=0.0002
    //t_watchdog表示的是看门狗计数计时器WTCNT每减少1所用的时间
    rWTDAT=20000; //WTDAT看门狗数据寄存器,看门狗定时器重载的计数值
    rWTCNT=20000; //WTCNT看门狗计数寄存器,看门狗定时器当前计数值
}

/**************************************************************
                        看门狗中断函数
**************************************************************/
void __irq watchdog_isr(){
    rSUBSRCPND |=1&lt;&lt;13; //清除次级中断挂起状态
    rSRCPND|=0x1&lt;&lt;9;    //清除中断挂起状态
    rINTPND|=0x1&lt;&lt;9;

   //中断LED点亮
    led_flag++;
    Uart_Printf(&quot;\n    -----看门狗中断，点亮LED %d\n&quot;,led_flag);
    rGPBCON=0x015400;
    switch(led_flag){
    case 1: rGPBDAT=0xe&lt;&lt;5 ;break;
    case 2: rGPBDAT=0xd&lt;&lt;5 ;break;
    case 3: rGPBDAT=0xb&lt;&lt;5 ;break;
    case 4: rGPBDAT=0x7&lt;&lt;5 ;break;
    }
    if(led_flag==4) led_flag=0;  

    rSUBSRCPND &amp;=(~0x1&lt;&lt;13);
    rSRCPND &amp;=(~0x1&lt;&lt;9);   //开中断
    rINTPND &amp;=(~0x1&lt;&lt;9);
}

/**************************************************************
                       看门狗子函数
**************************************************************/
void watchdog(){

    watchdog_init(); //初始化看门狗寄存器

    //选择是否开启复位
    //rWTCON |= (1&lt;&lt;0);//开启复位
    rWTCON |= (0&lt;&lt;0);//禁止复位

    rINTSUBMSK &amp;=~(1&lt;&lt;13);//开看门狗次级中断
    rINTMSK &amp;=~(1&lt;&lt;9);    //开看门狗中断
    pISR_WDT_AC97=(unsigned)watchdog_isr;

    while(1){
    }
}
</pre>
<p><P><A href="http://www.bubuko.com/infodetail-274419.html" rel="external nofollow noreferrer">mini2440裸机试炼之——看门狗中断和复位操作,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-25 18:57:04 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e4%b8%ad%e6%96%ad/" title="中断">中断</a>, <a href="https://www.biecuoliao.com/tag/%e5%a4%8d%e4%bd%8d/" title="复位">复位</a>, <a href="https://www.biecuoliao.com/tag/2440mini/" title="2440mini">2440mini</a>, <a href="https://www.biecuoliao.com/tag/%e7%9c%8b%e9%97%a8%e7%8b%97/" title="看门狗">看门狗</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>mini2440裸机试炼之——看门狗中断和复位操作的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QvBxwM.html" rel="bookmark">mini2440裸机试炼之&mdash;RTC闹钟中断，节拍中断</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				环境搭建 硬件环境:J-link v8.mini2440.J-link转接板.串口转USB线 软件环境:windows7(32位).开发板uboot(NandFlash).J-link驱动(J-Link ARM V4.10i).SecureCRT.ADS1.2 其中ADS里的AXD设置:加载JlinkRDI.dll+Options-&gt;Configure Interface...,在Session File一页中选择&quot;Run Configuration Script&quot;,将该name			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXGxVX4.html" rel="bookmark">mini2440裸机试炼之IIS&mdash;&mdash;音乐播放器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				IIS 信号频率设置 IIS(Inter-IC Sound)由飞利浦公司开发,是一种常用的音频设备接口,主要用于CD.MD.MP3等设备. s3c2440一共有5个引脚用于IIS:IISDO.IISDI.IISSCLK.IISLRCK和CDCLK.前两个引脚用于数字音频信号的输出和输入,另外三个引脚都与音频信号的频率有关,可见要用好IIS,就要把信号频率设置正确. IISSCLK为串行时钟,每一个时钟信号传送一位音频信号.因此IISSCLK的频率＝声道数×采样频率×采样位数,如采样频率fs为44			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35dqK10.html" rel="bookmark">mini2440裸机试炼之&mdash;&mdash;Uart与pc端实现文件、字符传输</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.  波特率(Baud rate)即调制速率,1波特即指每秒传输1个符号. 2.  非FIFO模式,即传输数据不利用FIFO缓存,一个字节一个字节地传输. 3.  接收到的数据是放到接收缓存器URXHn中,要发送数据时,是把数据放入发送缓存器UTXHn中.由于UART是通过字节方式传输数据的,因此要区分是大端模式还是小端模式,也就是说这两个寄存器在这两种模式下,所在的地址是不同.为了了解当前数据传输的各种状态,还需要一些状态寄存器.传输状态寄存器UTRSTATn非常有用,它的第0位可以用来判断			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0knxEzM.html" rel="bookmark">mini2440裸机试炼之&mdash;&mdash;整合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mini2440裸机试炼系列先在这里落尾了,写了一个裸机整合的系统,各功能的代码在之前都有介绍的 目录视图: 整合的bin文件下载			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49eGlD4.html" rel="bookmark">第三十七天：Tiny驱动开发之看门狗中断</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.    看门狗原理 Watchdog原理上就是一个定时器.定时器timer对时钟进行计数,当定时器溢出时,产生复位信号,使得整个系统复位.在程序或嵌入式系统中,需要 定期的对看门狗timer进行复位重新计数,定时器不会溢出复位系统,从而保证系统的正常运行.当某种原因(例如干扰)引起程序跑飞或者进入死循环时,程 序不能定期的复位看门狗timer, 计数溢出产生复位信号,导致系统复位. 设本系统程序完整运行一周期的时间是T1,看门狗的定时周期为T2,T2&gt;T1,在程序运行一周期后就修改定时器的计			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4p9RdyM.html" rel="bookmark">mini2440裸机试炼之&mdash;计算器&lpar;LCD显示&comma;触摸屏中断&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于T35 TFT LCD屏实现功能: 1. 在屏幕上画一个计算器界面,包括0-9,+,-,*,/: 2. 实现触摸选择界面上的数字和运算符, 3. 并计算出结果显示在显示框内. 注意,只实现整数功能,没涉及小数,只实现一次运算,不保存上次运算结果. 实现界面: 实现过程: 开启LCD电源,初始化LCD&gt;&gt;&gt;LCD填充界面图片&gt;&gt;&gt;开启触摸屏中断&gt;&gt;&gt;获取键值&gt;&gt;&gt;区分数字和功能来调用数字图片显示.   数字图片: 空白图: 除数为零			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38N1ERM.html" rel="bookmark">mini2440裸机试炼之&mdash;&mdash;DMA直接存取  实现Uart（串口）通信</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这个只能作为自己初步了解MDA的开门篇 实现功能: 将字符串数据通过DMA0通道传递给UTXH0,然后在终端 显示.数据传输完后,DMA0产生中断,beep声, LED亮. DMA基本知识 计算机系统中各种常用的数据输入/输出方法有查询方式(包括无条件及条件传送方式)和中断方式,这些方式适用于CPU与慢速及中速外设之间的数据交换.但当高速外设要与系统内存或者要在系统内存的不同区域之间进行大量数据的快速传送时,就在一定程度上限制了数据传送的速率.直接存储器存取(DMA)就是为解决这个问题提出的,采			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWqzJa3.html" rel="bookmark">mini2440裸机试炼之&mdash;&mdash;IIC控制EEPROM数据传输</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				内容: 向EEPROM(AT24C02)内部地址0x00-0xff,依次写入0x00-0xff,然后再读出数据. IIC总线介绍: IIC(Inter-IntegratedCircuit,I2C)总线是一种由PHILIPS公司开发的两线式串行总线,用于连接微处理器及其外围设备.在iic总线上,只需要两条线:串行数据线SDA和串行时钟线SCL,便可完成通信 IIC要点 1.  清IIC中断标志语句rIICCON&amp;= ~0x10;一定要在读写寄存器IICDS的后面,中断是读写寄存器后发生的: 2. 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MggoeNM.html" rel="bookmark">linux内核中断之看门狗</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一:内核中断 linux内核中的看门狗中断跟之前的裸板的中断差不多,在编写驱动之前,需要线把内核自带的watch dog模块裁剪掉,要不然会出现错误:在Device Drivers /Watchdog Timer Support /S3C2410 Watchdo 在内核中,我们处理一个中断,必须先注册一个中断号,注册中断的函数是: 132 request_irq(unsigned int irq, irq_handler_t handler, unsigned long flags, 133 c			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V0bzyL0.html" rel="bookmark" class="title">Day01 -- Java 环境变量</a>
					<div>
						Java 学习首先搭建开发环境 1.jdk 下载安装 在  ORACLE   官网下载对应的JDK最新版本 安装即可(安装过程默认会安装 jdk 和 jre) 2.环境变量设置 JDK开发环境需要设置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xgDnM.html" rel="bookmark" class="title">20170227H5&plus;css3属性随笔</a>
					<div>
						padding 简写属性在一个声明中设置所有内边距属性. margin 简写属性在一个声明中设置所有外边距属性. placeholder 属性提供可描述输入字段预期值的提示信息(hint). alt  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j4NmD83.html" rel="bookmark" class="title">extjs6入门：用sencha cmd搭建简单的extjs6项目</a>
					<div>
						开发准备 1.sencha cmd安装 2.extjs6.0.0 gpl正式版下载,地址:https://www.sencha.com/legal/gpl/ ,解压ext-6.0.0-gpl.zip  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4APnLb3.html" rel="bookmark" class="title">【c语言】输入一组整数&comma;求出最大子序列的和</a>
					<div>
						// 输入一组整数,求出最大子序列的和. // 例如:序列: - 2 11 - 4 13 - 5 - 2,则最大子序列和为20. // 序列: - 6 2 4 - 7 5 3 2 - 1 6 - 9  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nEAVxM.html" rel="bookmark" class="title">一些重要的图</a>
					<div>
						1—创建和使用共享库 2.2malloc与sbrk 3.3打开文件的内核数据结构 4.4函数stat结构体 5.5 Unix进程间共享信息的三种方式 6.6各种形式IPC的命名空间 7.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWAQPl3.html" rel="bookmark" class="title">Collections工具类</a>
					<div>
						1 操作Collection及Map工具类 package lianxi2; import java.util.ArrayList; import java.util.Arrays; import j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRpjr4.html" rel="bookmark" class="title">设计模式大总结（二）</a>
					<div>
						上篇博客给大家介绍了六大原则和设计模式之间的关系,以及创建型模式和结构型模式 (http://blog.csdn.net/zhangzijiejiayou/article/details/327127 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AmNVz4.html" rel="bookmark" class="title">HTML5&plus;CSS3静态页面项目-PayPaul的总结</a>
					<div>
						学习前端有一段时间了,一直在看书上的理论知识,而实战项目却很少.师兄常说,想要知道自己的实力有多少,知识掌握了多少,最好的方法就是去实践了,实践出真知嘛.于是决定在这个假期里,主要是通过项目的实践以及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wyPplM.html" rel="bookmark" class="title">python面向对象1</a>
					<div>
						面向对象技术简介 类(Class): 用来描述具有相同的属性和方法的对象的集合.它定义了该集合中每个对象所共有的属性和方法.对象是类的实例. 类变量:类变量在整个实例化的对象中是公用的.类变量定义在类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OR1xZ0.html" rel="bookmark" class="title">day3（if ，while，switch等语句的应用实例）</a>
					<div>
						上午练习情况: package com.chinasoft.javase.AM; public class myTest { public static void main(String[] args ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZwZ93.html" rel="bookmark" class="title">美国队长3&amp;&num;160&semi;高清完整版下载</a>
					<div>
						关注微信公众账号:“极客峰”,回复“美国队长3”获取高清视频资源. 注:本高清完整视频资源仅供学习交流使用,如需欣赏,请支持正版-					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQgX8M.html" rel="bookmark" class="title">AEAI HR V1&period;5&period;1升级说明，开源人力资源管理系统</a>
					<div>
						本次发版的AEAI HR_v1.5.1版本为AEAI HR_v1.5.0版本的升级版本,该产品现已开源并上传至开源社区http://www.oschina.net/p/aeaihr. 1 升级说明 A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/382WJRM.html" rel="bookmark" class="title">a股最大单日跌幅&comma;李登辉出卖钓鱼岛</a>
					<div>
						http://passport.baidu.com/?business&amp;un=3&amp;un=%E4%B8%AD%E5%8E%9F%E6%89%BE%E5%A6%B9%E5%AD%90%E5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBYJKE4.html" rel="bookmark" class="title">Java - Excel 导入 导出，报无效数据</a>
					<div>
						用Java,做了套后台账号管理系统,内有Excel导入导出模块 后台管理员登录后,可以通过&lt;input type=&quot;file&quot;&gt;,读取指定格式的Excel工作薄 系统会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NqZaG3.html" rel="bookmark" class="title">LR杂记-nmon&plus;analyser监控linux系统资源</a>
					<div>
						1.查看linux具体版本号信息 file /sbin/init 2.下载相应nmon版本号 http://pkgs.repoforge.org/nmon/ 3.安装 rpm -ivh nmon-14 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vzvwk3.html" rel="bookmark" class="title">myEclipse 导入maven项目时报错</a>
					<div>
						1.先右击项目,build Path 查看是否是某个JAR出了错.去掉无用的JAR 以及修改对应的JDK版本 2.检查src源文件,查看是否是源文件出了错.发现,还真的是 导入的包上面,报错:The  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbv5X3.html" rel="bookmark" class="title">java 求主机IP地址及其相对应的子网掩码</a>
					<div>
						不多说,直接上代码. package com.ckw.test; import java.io.BufferedReader; import java.io.IOException; import j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWqja63.html" rel="bookmark" class="title">等价类划分方法应用</a>
					<div>
						问题: 允许1到6个英文字符或数字,按OK结束 有效等价类: 长度:1到6 字符:a-z,A-Z,0-9 无效等价类 长度:0,7 字符:英文/数字以外字符,控制字符,标点符号 有效等价类 无效等价类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KvEomM.html" rel="bookmark" class="title">MAC下使用pyenv&plus;virtualenv 控制环境版本</a>
					<div>
						今天想搭建Django环境 发现 默认的Python版本是2.7  但是本人十分喜欢3.0以上的版本 ,木有办法 搭建一个虚拟环境吧,顺便记录一下安装过程,方便以后查看 打开终端 步骤: 1.安装py ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eEGLa0.html" rel="bookmark" class="title">7正则表达式</a>
					<div>
						在前面我们已经搞定了怎样获取页面的内容,不过还差一步,这么多杂乱的代码夹杂文字我们怎样把它提取出来整理呢?下面就开始介绍一个十分强大的工具,正则表达式! 1.了解正则表达式 正则表达式是对字符串操作的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
